/*------------------------------------------------*/
/* konverze/mbswcstest.c                          */
#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>  /* printf() */
#include <stdlib.h> /* EXIT_FAILURE */
#include <locale.h> /* setlocale() */
#include <string.h> /* memset() */
#include <errno.h>  /* peror() */
#include <wchar.h>

#define MAX_WLEN 10

int main(void) {
    wchar_t res[MAX_WLEN];    
    char mbs[] = "Já jsem ♥utf-8♥ textíček.";
    char *u = mbs;
    char **src = &u;
    mbstate_t state;
    wchar_t * wu = res;
    wchar_t ** wsrc = &wu;
    size_t len;
    memset (&state, '\0', sizeof (state));

    printf("Locale:\t%s\n", setlocale(LC_ALL,""));

    len = mbsrtowcs (res, (const char **) src, MAX_WLEN-1, &state);
    if(((size_t) -1) == len) {
        perror(NULL);
	return EXIT_FAILURE;
    }
    res[len] = L'\0';
    printf("mbs\t= %s\n", mbs);
    printf("res\t= %ls\n", res);
    printf("Zbytek\t= %s\n", u);
    
    memset (&state, '\0', sizeof (state));
    wcsrtombs(mbs, (const wchar_t **) wsrc, sizeof(res), &state); 
    printf("mbs\t= %s\n", mbs);

    return 0;
}

/*------------------------------------------------*/
